/*
**	main.c
**
*/
#include "mpeg.h"
#define SX 704
#define SY 480
#define SCX (SX/2)
#define SCY (SY/2)

struct sif { unsigned char y[SY][SX]; unsigned char c[2][SCY][SCX]; };
typedef struct	sif SIF;
SIF image;
int cmp,ddt,x2=1,vhs,bgc,wid,step,pause,sync=1;
double cur, startt, spent;
char name[20];

struct poi{ float x; float y; float z; };
typedef struct poi Pt;
Pt point(x,y,z) { Pt p; p.x= x; p.y= y; p.z= z; return p; }
float ip(p,q) Pt p,q; { float r; r= p.x*q.x+ p.y*q.y + p.z*q.z; return r; }
Pt padd(a,b) Pt a,b; { a.x+=b.x; a.y+=b.y; a.z+=b.z; return a; }
Pt psub(a,b) Pt a,b; { a.x-=b.x; a.y-=b.y; a.z-=b.z; return a; }
Pt smp(k,p) float k; Pt p; { p.x*= k; p.y*= k; p.z*= k; return p; }
Pt norm(p)  Pt p; { return smp((float)sqrt(1./(p.x*p.x +p.y*p.y +p.z*p.z)),p); }

float cos1= 0.5;
float sin1= 1.7320508/2.;
float cos2= 0.9659;
float sin2= 0.2588;

Pt rotate(p) Pt p;
{ 
	float t;
	t=   p.x*cos1 -p.z*sin1;
	p.z= p.x*sin1 +p.z*cos1;
	p.x= t;
	t=   p.y*cos2 -p.z*sin2;
	p.z= p.y*sin2 +p.z*cos2;
	p.y= t;
	return p;
}

float distant(a,v) Pt a,v;
{
	float t1,t2,t3,r;

	t1= a.x*v.y-a.y*v.x;
	t2= a.y*v.z-a.z*v.y;
	t3= a.z*v.x-a.x*v.z;
	r= t1*t1+t2*t2+t3*t3;
	return r;
}

int rgb[16]= {
0x001040, 0x001030, 0xD0D000, 0xD0D050,
0x005010, 0x005010, 0xD0D000, 0xD0D050,//doubling of the upper line
0x3030FF, 0x5050D0, 0xF09010, 0xF09040,
0xF0F0F0, 0xF0F080, 0xF09010, 0xF09040,//doubling of the upper line
};
int yuv[16][3];
/*
up,cross2,cross, ref 
0   0   0	0: outside bottom dark blue =  #001040;
0   0   0	1: inside bottom dark blue =  #001030;
0   1	0	0: outside underfloor green= #003010;
0   1	0	1: inside underfloor green= #004010;
0    x	1	0: outside floor yellow= #D0D000;
0    x	1	1: inside floor yellow= #D0D050;

1   0   0	0: outside sky blue =  #3030FF;
1   0   0	1: inside sky blue =   #5050D0;
1   1	0	0: outside 2nd seiling white= #F0F0F0;
1   1	0	1: inside 2nd seiling white= #F0F080;
1    x	1	0: outside seiling orange= #F09010;
1    x	1	1: inside seiling orange=  #F09000;
*/
clr(i,j,p,v,ref)
Pt p,v;
	{
	float t;
	int	ix,iz;
	int	luma,cb,cr;
	int	up,cross,cross2=0;
	int	ind;

	up= (v.y>0);
	t= (-SCY+SY*up-p.y)/v.y;
	ix= v.x*t+ p.x;
	iz= v.z*t+ p.z;
	ix= ix>>(8+up);
	iz= iz>>7;
	cross= ((ix&1)==(iz&1));
	if(cross==0){
		t= (-SY*2+(SY*4)*up-p.y)/v.y;
		ix= v.x*t+ p.x;
		iz= v.z*t+ p.z;
		ix= ix>>(7+up);
		iz= iz>>7;
		cross2= ((ix&1)==(iz&1));
		}
#define SET_COLOR
#ifdef SET_COLOR
	ind= up*8+cross2*4+cross*2+ref;
	image.y[j][i]= yuv[ind][0];
	if((i&1)==0&&(j&1)==0){
		image.c[0][j/2][i/2]= yuv[ind][1];
		image.c[1][j/2][i/2]= yuv[ind][2];
		}
#else
	luma= 60+cross2*80+cross*180;
	image.y[j][i]= luma;
	if((i&1)==0&&(j&1)==0){
		cb= 100+cross2*20+up*40;
		cr= 80+cross*25+ref*50;
		image.c[0][j/2][i/2]= cb;
		image.c[1][j/2][i/2]= cr;
		}
#endif
	}

lay(t0)
	{
	int	i,j;
	Pt eye,a,b;
	float c1,r0=300;
	float t= t0;//+0.5*(j&1);
	float r2=r0*r0;

#define circle
#ifdef circle
	a= point((int)(-2000*sin(t/50))+1500,-50,-(int)(200*cos(t/50))); 
#else
	t= t+t*t/4;
	a= point(-500-(int)t,-100,(int)t); 
#endif
	eye= smp(0.5, a);
	b= psub(a,eye);
	c1= ip(b,b)-r2;

	for(j=0;j<SY;j++){


		for(i=0;i<SX;i++){
			int	ref=0;
			Pt p0= eye;
			Pt v= norm(rotate(point(i-SCX, SCY-j, SX)));

			if(distant(b,v)< r2) {
				float b1,k;
				Pt p1;
	
				b1= ip(b,v);
				p1= padd( eye, smp(b1-sqrt(b1*b1-c1), v) );
				k= -2.*ip(v,psub(p1,a))/r2;
				v= norm( padd( v, smp( k, psub(p1,a) ) ) );
				p0= p1;
				ref= 1;
				}
			clr(i,j,p0,v,ref);
			}
		}
	}

/*
up,cross2,cross, ref 
0   0   0	0: outside bottom dark blue =  #001030;
0   0   0	1: inside bottom dark blue =  #002030;
0   1	0	0: outside underfloor green= #003010;
0   1	0	1: inside underfloor green= #004010;
0    x	1	0: outside floor yellow= #505010;
0    x	1	1: inside floor yellow= #505020;

1   0   0	0: outside sky blue =  #5050F0;
1   0   0	1: inside sky blue =  #5050E0;
1   1	0	0: outside 2nd seiling orange= #906010;
1   1	0	1: inside 2nd seiling orange=  #906010;
1    x	1	0: outside seiling mosswhilte= #E0E0E0;
1    x	1	1: inside seiling mosswhilte= #E0E0D0;
*/
set_color(){
	int i;
	for(i=0;i<16;i++){
		float r,g,b,y,cb,cr;

		r= (rgb[i]>>16)&255;
		g= (rgb[i]>>8)&255;
		b= (rgb[i])&255;
		r/= 255.;
		g/= 255.;
		b/= 255.;
		y= 0.299*r+0.587*g+0.114*b;
		cb= 0.564*(b-y);
		cr= 0.713*(r-y);
		yuv[i][0]= (int)(y*219+16);
		yuv[i][1]= (int)(cb*224+128);
		yuv[i][2]= (int)(cr*224+128);
	}
}

main(argc, argv) int argc; char	**argv;
	{
	int i;
	if(argc!=1){ fprintf(stderr,"Usage: %s\n",argv[0]); exit(1); }
	set_color();
	iwt(argv[0],&image,SX,SY);
	for(i= 0;i<=1000;i++){
		lay(i);
		sprintf(name,"%s%0d",argv[0],i);
		wt(name,&image);
		if(pause){ i--; if(step) { i+=step; step= 0;} usleep(100000); }
		}
	}
